-- 限时礼包，不走通用活动界面
Lua_LimitTimeGiftWindow = class("Lua_LimitTimeGiftWindow", Lua_Window);
function Lua_LimitTimeGiftWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_LimitTimeGiftWindow";
	self.skinName = "LimitTimeGiftWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -560;
end

function Lua_LimitTimeGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.giftItemArr = Array();
	self.scrollContainer = UICreate.createScrollContainer(self.content, 0, 0, 600, 112); -- 父节点,x,y,宽,高
	self.scrollContainer.horizontal = false; -- 水平
	self.scrollContainer.vertical = false; -- 垂直
	self.scrollContainer.movementTypeValue = 1; -- 0不限制 会超出设置宽(水平)高(垂直) 1弹性 超出会回弹 2硬限制 不会超出设置宽(水平)高(垂直)
	self.scrollContainer.elasticity = 0.3; -- 弹性
	self.scrollContainer.inertia = true; -- 惯性
	self.scrollContainer:setScrollSize(0, 0); -- content 的 RectTransform 的 sizeDelta
	self.scrollContainer:setScrollPivot(4); -- content 的 RectTransform 的 pivot
	self.scrollContainer:setScrollAnchor(0.5, 0.5, 0.5, 0.5); -- content 的 RectTransform 的 anchor
	self.scrollContainer:setScrollPosition(0, 0, 0); -- content 的 RectTransform 的 pos
	-- self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun); -- 按下监听
	-- self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun); -- 抬起监听
	self.scrollContainer:addMask(); -- 隐藏其他区域
	self.sub = self.scrollContainer.scrollContent; -- content
	LuaUtil.setObjPos(self.scrollContainer.mainContent, 0, -83, 0);

	self.sloganNum = Lua_NumberImage.new(self.content);
	self.sloganNum.pivot = 1;
	self.sloganNum.numOffsetX = -3;
	self.sloganNum.numAtlas = "number";

	self.mainItemW = 130;
	self.mainItemH = 90;
	self.actList = Lua_DragList.new(self.content, 700, self.mainItemH, Lua_AxisDefine.Horizontal);
	self.actList.clickMoveOffset = 1;
	self.actList:setListCell(Lua_LimitTimeGiftMainBtnItem, self.mainItemW, self.mainItemH, 1);
	self.actList:setLocation(0, -414, 0);

	self.leftIcon:addClickFuntion(self, self.onLeftBtnClick);
	self.rightIcon:addClickFuntion(self, self.onRightBtnClick);
	self.buyBtn:addClickFuntion(self, self.onBuyClick);

	self:addLuaEvent("LIMITTIMEGIFT_ITEM_SELECT", self, self.onMainBtnClick);
	self:addLuaEvent("UPDATE_LIMITIMEGIFT_INFO", self, self.updateGiftShowInfo);
end

function Lua_LimitTimeGiftWindow:showWin(param)
	self:superCall("showWin", param);
	self:checkGiftShow();
end

function Lua_LimitTimeGiftWindow:checkGiftShow(limitVo)
	local arr = DataCenter.limtiTimeGiftData.limitTypeArr;
	if arr:getSize() <= 0 then -- 打开界面刚刚好全部活动都已经结束
		OperateAlert.showLangValue(530000);
		self:hide();
	else
		self:setlimitGiftInfo(arr, limitVo);
		DataCenter.limtiTimeGiftData:checkPopupInfo();
	end
end

function Lua_LimitTimeGiftWindow:setlimitGiftInfo(arr, limitVo)
	local selectIdx = 1;
	if type(self.showData) == "table" then
		if self.showData.giftType == nil then
			selectIdx = 1;
		else
			selectIdx = self:getSelectIdx(arr, self.showData.giftType, 1);
		end
	elseif type(self.showData) == "number" then
		selectIdx = self:getSelectIdx(arr, self.showData, 1);
	end
	if limitVo ~= nil then
		selectIdx = self:getSelectIdx(arr, limitVo.giftType, 1);
	end

	local width = arr:getSize() > 5 and 700 or self.mainItemW * arr:getSize();
	self.actList.canDrag = arr:getSize() > 5;
	self.actList:setContentRect(width, self.mainItemH);
	self.actList:setArrayData(arr);
	self.actList:moveToIndex(selectIdx, true);
	self.actList:setSelectClick(selectIdx);
	self.actList:setSelected(selectIdx);
	self.actList:setEnable(arr:getSize() > 1);
end

-- 获取选中索引，并且设置是否当前界面显示的活动
function Lua_LimitTimeGiftWindow:getSelectIdx(arr, param, selectType)
	local selectIdx = 1;
	for i = 1, arr:getSize() do
		if selectType == 1 then -- 一级页签
			if arr[i] == param then
				selectIdx = i;
				break;
			end
		elseif selectType == 2 then -- 二级页签
			if arr[i].id == param then
				selectIdx = i;
				break;
			end
		end
	end
	return selectIdx;
end

function Lua_LimitTimeGiftWindow:onMainBtnClick(giftType)
	local limitTimeConst = DataCenter.limtiTimeGiftData.limitTimeConst;
	self.sloganNum.preStr = limitTimeConst.num_pre_icon[giftType];

	local arr = DataCenter.limtiTimeGiftData:getGiftShowArr(giftType); -- 切换一级页签，重新加载二级页签
	self.actLen = arr:getSize();
	
	local selectIdx = 1;
	if arr:getSize() > 1 then
		if type(self.showData) == "table" then
			if self.showData.id == nil then
				selectIdx = 1;
			else
				selectIdx = self:getSelectIdx(arr, self.showData.id, 2);
			end
		elseif type(self.showData) == "number" then
			selectIdx = self:getSelectIdx(arr, self.showData, 2);
		end
		self.showIdx = selectIdx;

		if self.btnList == nil then
			self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
			self.btnList:setButtonCell(Lua_LimitTimeGiftBtnSubItem);
			self.btnList:setButtonItem(36, 30);
			self.btnList:setClickCallBack(self, self.onSubBtnClick);
			self.btnList:setLocation(0, -329, 0);
		end
		self.btnList:setEnable(true);
		self.btnList:setData(arr);
		self.btnList:setSelected(selectIdx);
	else
		self.showIdx = 1;
		if self.btnList ~= nil then
			self.btnList:setEnable(false);
		end
		self:updateShowInfo(arr[1]);
	end

	local item;
	for i = 1, arr:getSize() do
		item = self.giftItemArr[i];
		if item == nil then
			item = Lua_LimitTimeGiftRewardItem.new(self.sub);
			self.giftItemArr:add(item);
		end
		item.contentName = "Lua_LimitTimeGiftRewardItem" .. i;
		item:setData(arr[i]);
		item:setLocation((i - 1) * 600, 0, 0);
	end
	self:playLTTween(selectIdx, false);

	if self.giftType == giftType then
		return;
	end
	self.giftType = giftType;

	local winBgImg = limitTimeConst.win_bg_img[giftType];
	if not strIsNullOrEmpty(winBgImg) then
		self.winBg:setUrl(limitTimeConst.win_bg_url .. winBgImg);
	end
	self.sloganIcon:setAltas(limitTimeConst.num_art_icon[giftType][1], limitTimeConst.num_art_icon[giftType][2]);
	self.sloganIcon:resetSize();
	self.timeBg:setAltas(limitTimeConst.time_icon[giftType][1], limitTimeConst.time_icon[giftType][2]);

	local timeColor = limitTimeConst.time_color[giftType];
	self.timeTxt.colorStr = Lua_ColorDefine.transColorStr(timeColor);

	local limitTimesColor = limitTimeConst.limit_times_color[giftType];
	self.leftTimesTxt.colorStr = Lua_ColorDefine.transColorStr(limitTimesColor);

	local desBgIcon = limitTimeConst.des_icon_list[giftType];
	self.desBg:setAltas(desBgIcon[1], desBgIcon[2]);
	self.showData = nil;
end

function Lua_LimitTimeGiftWindow:updateShowInfo(limitVo)
	if self.limitVo ~= nil and limitVo.endTime <= 0 then
		OperateAlert.showLangValue(530000); -- 切换二级页签，按照现在框架逻辑不进行移除
		-- self.showData = self.limitVo;
		-- self:checkGiftShow(self.limitVo); -- 回到之前的页签
		-- return;
	end
	self.limitVo = limitVo;
	self.leftIcon:setEnable(self.showIdx > 1);
	self.rightIcon:setEnable(self.showIdx < self.actLen);

	self:updateGiftShowInfo();
end

function Lua_LimitTimeGiftWindow:updateGiftShowInfo()
	self.desTxt.text = self.limitVo.desStr;

	local times = self.limitVo.leftTimes > 0 and self.limitVo.leftTimes or "<color=#C62A0F>"..self.limitVo.leftTimes.."</color>";
	self.leftTimesTxt.text = LanUtil.formateStr(530001, times, self.limitVo.limitTimes);

	self.sloganNum.num = self.limitVo.sloganValue;
	local totalWidth = self.sloganNum.totalWidth + self.sloganIcon.width;
	self.sloganNum:setLocation(-totalWidth / 2, 106, 0);
	self.sloganIcon:setLocation(self.sloganNum.posX + self.sloganNum.totalWidth, 50, 0);

	if self.limitVo.endTime > 0 then
		self.buyBtn.label = LanUtil.formateStr(530002, self.limitVo.recharge);
	else
		if self.limitVo.leftTimes > 0 then
			self.buyBtn:setLangValue(530004); -- 已失效
		else
			self.buyBtn:setLangValue(530005); -- 已购买
		end
	end

	self:startTimer();
	self:updateLeftTime();
end

function Lua_LimitTimeGiftWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_LimitTimeGiftWindow", 1, self, self.updateLeftTime);
	end
end

function Lua_LimitTimeGiftWindow:updateLeftTime()
	local time = self.limitVo.endTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
		if self.isCheck then
			Lua_ProxyManager.getProxy("Lua_LimitTimeGiftProxy"):sLimitTimeGiftInfo();
		end
	end
	self.isCheck = time > 0;
	self.timeTxt.text = LanUtil.formateStr(530003, Lua_TimeTransform.transSeconds6(time, true, true, true));
end

function Lua_LimitTimeGiftWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_LimitTimeGiftWindow:onSubBtnClick(idx, limitVo)
	self:updateShowInfo(limitVo);
end

function Lua_LimitTimeGiftWindow:onLeftBtnClick(go)
	if self.showIdx <= 1 or self.isClick then
		return;
	end
	self.showIdx = self.showIdx - 1;
	self:updateRewardInfo(self.showIdx);
end

function Lua_LimitTimeGiftWindow:onRightBtnClick(go)
	if self.showIdx >= self.actLen or self.isClick then
		return;
	end
	self.showIdx = self.showIdx + 1;
	self:updateRewardInfo(self.showIdx);
end

function Lua_LimitTimeGiftWindow:updateRewardInfo(index)
	self.leftIcon:setEnable(index > 1);
	self.rightIcon:setEnable(index < self.actLen);
	self.btnList:setSelected(index);
	self:playLTTween(index, true);
end

function Lua_LimitTimeGiftWindow:playLTTween(showIdx, isMove)
	if self.preIdx == showIdx then
		return;
	end

	self:stopLTTween();
	if not isMove then
		LuaUtil.setObjPos(self.sub, -(showIdx - 1) * 600, 0, 0);
	else
		-- self.isClick = true; -- 不加限制
		local posX = -(showIdx - 1) * 600;
		TweenUtil.getInstance():addTween(self.sub, 2, 0,
		posX, 0, 0,
		0, 0, 0,
		1, 1, 1,
		self, self.stopLTTween, 0, false);
	end
	self.preIdx = showIdx;
end

function Lua_LimitTimeGiftWindow:stopLTTween()
	-- self.isClick = false;
	TweenUtil.getInstance():stop(self.sub);
end

function Lua_LimitTimeGiftWindow:onBuyClick(go)
	if self.limitVo.endTime > 0 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.limitVo.id);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		if self.limitVo.leftTimes > 0 then
			OperateAlert.showLangValue(530004);
		else
			OperateAlert.showLangValue(530005);
		end
	end
end

function Lua_LimitTimeGiftWindow:dispose()
	if self.giftItemArr ~= nil then
		self.giftItemArr:dispose();
		self.giftItemArr:clear();
		self.giftItemArr = nil;
	end
	if self.scrollContainer ~= nil then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	if self.actList ~= nil then
		self.actList:dispose();
		self.actList = nil;
	end
	self:endTimer();
	self:stopLTTween();
	self.giftType = nil;
	self.limitVo = nil;
	self.sub = nil;

	self:superCall("dispose");
end










Lua_LimitTimeGiftMainBtnItem = class("Lua_LimitTimeGiftMainBtnItem", Lua_ListCell)
function Lua_LimitTimeGiftMainBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LimitTimeGiftMainBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.icon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0);
	self.nameTxt = UICreate.createLabel(self.content, "", 0, 0, 52, 52, 26);
	self.nameTxt.fontName = Lua_MyUISettings.huakangFontName;
end

function Lua_LimitTimeGiftMainBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = DataCenter.limtiTimeGiftData.limitTimeConst.gift_name_list[data];
end

function Lua_LimitTimeGiftMainBtnItem:onPressClick()
	local isHaveGift = DataCenter.limtiTimeGiftData:getGiftShowState(self._data);
	if not isHaveGift then
		OperateAlert.showLangValue(530000);
		return false;
	end
	Lua_MsgUtil.callFunc("LIMITTIMEGIFT_ITEM_SELECT", self._data);
	return true;
end

function Lua_LimitTimeGiftMainBtnItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	if bSelect then
		self.icon:setAltas("limittime_gift_atlas", "xui_xslb_toggle_002_f");
		self.nameTxt.colorStr = Lua_ColorDefine.transColorStr("8A5A37");
	else
		self.icon:setAltas("limittime_gift_atlas", "xui_xslb_toggle_002_b");
		self.nameTxt.colorStr = Lua_ColorDefine.transColorStr("78685B");
	end
end

function Lua_LimitTimeGiftMainBtnItem:dispose()
	if self.icon ~= nil then
		self.icon:dispose();
		self.icon = nil;
	end
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_LimitTimeGiftBtnSubItem = class("Lua_LimitTimeGiftBtnSubItem", Lua_ButtonCell)
function Lua_LimitTimeGiftBtnSubItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LimitTimeGiftBtnSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.icon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0);
end

function Lua_LimitTimeGiftBtnSubItem:setSelected(index)
	if index == self.index then
		self.icon:setAltas("limittime_gift_atlas", "xui_xslb_widget_7");
	else
		self.icon:setAltas("limittime_gift_atlas", "xui_xslb_widget_8");
	end
end

function Lua_LimitTimeGiftBtnSubItem:dispose()
	if self.icon ~= nil then
		self.icon:dispose();
		self.icon = nil;
	end
	self:superCall("dispose");
end










Lua_LimitTimeGiftRewardItem = class("Lua_LimitTimeGiftRewardItem", Lua_ListCell)
function Lua_LimitTimeGiftRewardItem:ctor(p)
	self:superCall("ctor", p);

	self.rewardSubList = Lua_DragList.new(self.content, 580, 112, Lua_AxisDefine.Horizontal);
	self.rewardSubList:setListCell(Lua_LimitTimeGiftRewardSubItem, 116, 112, 1);
	self:addLuaEvent("UPDATE_LIMITIMEGIFT_INFO", self, self.updateRewardInfo);
end

function Lua_LimitTimeGiftRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local rewardInfo = data.rewardItem;
	local width = 116 * #rewardInfo > 580 and 580 or 116 * #rewardInfo;
	self.rewardSubList.canDrag = #rewardInfo > 5;
	self.rewardSubList:setContentRect(width, 112);
	self.rewardSubList:setArrayData(rewardInfo);

	self:updateRewardInfo();
end

function Lua_LimitTimeGiftRewardItem:updateRewardInfo()
	local itemArr = self.rewardSubList.showDragDataList;
	for i = 1, itemArr:getSize() do
		itemArr[i].cell:setDrawState(self._data.leftTimes <= 0);
	end
end

function Lua_LimitTimeGiftRewardItem:dispose()
	if self.rewardSubList ~= nil then
		self.rewardSubList:dispose();
		self.rewardSubList = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_LimitTimeGiftRewardSubItem = class("Lua_LimitTimeGiftRewardSubItem", Lua_ItemIconCell);
function Lua_LimitTimeGiftRewardSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.9, 0.9);
end

function Lua_LimitTimeGiftRewardSubItem:setDrawState(state)
	self.itemIcon:setDrawMask(state);
end